SLASH_SWAPCHECK1, SLASH_SWAPCHECK2 = '/swpchk', '/swapcheck';
local waitTable = {};
local recordedCoordTable = {};
local raidNames = {};
local waitFrame = nil;
local playerX = nil;
local playerY = nil;
local startTime = nil;
local endTime  = nil;
swpChkEnabled = nil;
announceType = "AUTO";

local avgSqMapUnitsX, avgSqMapUnitsY;
local lastCalcMapSize;

local function slashHandler(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	if command == "enable" then
		swpChkEnabled = 1
		print("SwapCheck is |cff00ff00Enabled|r");
	elseif command == "disable" then
		swpChkEnabled = 0
		print("SwapCheck is |cffff0000Disabled|r");
	elseif command == "test" then
		InstanceTest();
	elseif command == "help" then
		print("SwapCheck Commands:\nenable - Turns on SwapCheck\ndisable - Turns off Swapcheck\nsettings - Displays active settings\nannounce (type) - Sets what channel to announce swaps to\n(commmand) help - gives specific information on a command");
	elseif command == "settings" then
		if swpChkEnabled == 1 then
			print("SwapCheck is |cff00ff00Enabled|r");
		else
			print("SwapCheck is |cffff0000Disabled|r");
		end
		if announceType == "AUTO" then
			print("SwapCheck announcements are set to |cff00ff00Automatic|r");
		elseif announceType == "OFFICER" then
			print("SwapCheck announcements are set to |cff40C040Officer Chat|r");
		elseif announceType == "debug" then
			print("SwapCheck announcements are set to Local");
		elseif announceType == "GUILD" then
			print("SwapCheck announcements are set to |cff40FF40Guild Chat|r");
		elseif announceType == "INSTANCE_CHAT" then
			print("SwapCheck announcements are set to |cffFF4809Instance Chat|r");
		elseif announceType == "SAY" then
			print("SwapCheck announcements are set to |cffffffffSay|r");
		elseif announceType == "PARTY" then
			print("SwapCheck announcements are set to |cffAAAAFFParty Chat|r");
		elseif announceType == "RAID" then
			print("SwapCheck announcements are set to |cffFF4809Raid Chat|r");
		end
	elseif command == "announce" and rest ~= "" then
		if rest == "help" then
			print("SwapCheck Commands:\nannounce a - Set announcement type to |cff00ff00Automatic|r\nannounce o - Set announcement type to |cff40C040Officer Chat|r\nannounce s - Set announcement type to |cffffffffSay|r\nannounce p - Set announcement type to |cffAAAAFFParty|r\nannounce r - Set announcement type to |cffFF4809Raid/Instance|r");
		elseif rest == "a" then
			print("SwapCheck announcements are set to |cff00ff00Automatic|r");
			announceType = "AUTO";
		elseif rest == "d" then
			print("SwapCheck announcements are set to local");
			announceType = "debug";
		elseif rest == "g" then
			print("SwapCheck announcements are set to |cff40FF40Guild Chat|r");
			announceType = "GUILD";
		elseif rest == "o" then
			print("SwapCheck announcements are set to |cff40C040Officer Chat|r");
			announceType = "OFFICER";
		elseif rest == "i" then
			print("SwapCheck announcements are set to |cffFF4809Instance|r");
			announceType = "INSTANCE_CHAT";
		elseif rest == "s" then
			print("SwapCheck announcements are set to |cffffffffSay|r");
			announceType = "SAY";
		elseif rest == "p" then
			print("SwapCheck announcements are set to |cffAAAAFFParty|r");
			announceType = "PARTY";
		elseif rest == "r" then
			print("SwapCheck announcements are set to |cffFF4809Raid|r");
			announceType = "RAID";
		end  
	elseif command == "debug" then
		print("announceType: " .. announceType);
		print("swpChkEnabled: " .. swpChkEnabled);
		if UnitInRaid("player") ~= nil then
			print("GetPartyLFGID: true");
		else
			print("GetPartyLFGID: nil");
		end
		
		if UnitInParty("player") ~= nil then
			print("GetPartyLFGID: true");
		else
			print("GetPartyLFGID: nil");
		end
		
		if GetPartyLFGID() ~= nil then
			print("GetPartyLFGID: " .. GetPartyLFGID());
		else
			print("GetPartyLFGID: nil");
		end
	else
  -- If not handled above, display some sort of help message
		print("Unrecognized Command. Type /swapcheck help for a list of commands.");	
	end
end

SlashCmdList["SWAPCHECK"] = slashHandler;

function SwapCheck__wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

function determineYardsMoved(startX, startY, endX, endY)
	local yardsMoved = sqrt(sqrt((abs(startX-endX)^2)+(abs(startY-endY)^2))*((avgSqMapUnitsX+avgSqMapUnitsY)/2))/1.075;
	return yardsMoved;
end

function RecordLocation()
	playerX, playerY = GetPlayerMapPosition("player");
end

function mapCalcMapSize(unitID)
	--Single Calculation based on swapcaster
	local myX, myY, exX, exY, hypoUnits, hypoFactor;
	myX, myY = GetPlayerMapPosition("player");
	exX, exY = GetPlayerMapPosition(unitID);
	hypoUnits, _ = UnitDistanceSquared(unitID);
	hypoFactor = sqrt((abs(myX-exX)^2)+(abs(myY-exY)^2));
	avgSqMapUnitsX = ((abs(myX-exX)/hypoFactor)*hypoUnits)*(1/abs(myX-exX));
	avgSqMapUnitsY = ((abs(myY-exY)/hypoFactor)*hypoUnits)*(1/abs(myY-exY));
	lastCalcMapSize = GetTime();
end

function SwapCheck(unitID)
	local inRaid, inParty, victimID, postX, postY, curSpeed, moveThreshold;
	victimID = nil;
	inRaid = UnitInRaid("player");
	inParty = UnitInParty("player");
	curSpeed = GetUnitSpeed("player");
	moveThreshold = 0.1+(2*(curSpeed/7));
	postX, postY = GetPlayerMapPosition("player");
	if determineYardsMoved(playerX, playerY, postX, postY) >= moveThreshold then
		victimID = "player";
	end
	
	if victimID ~= nil then
		local inRaid = UnitInRaid("player");
		local inParty = UnitInParty("player");
		local raidCheck = string.find(unitID,"raid");
		local inInstance, instanceType = IsInInstance();
		if announceType == "AUTO" then
			local autoChannel;
			if inRaid == nil and inParty ~= nil then
				if GetPartyLFGID() ~= nil then
					autoChannel = "INSTANCE_CHAT";
				else
					autoChannel = "PARTY";
				end
			elseif inRaid ~= nil and raidCheck ~= nil then
				if GetPartyLFGID() ~= nil then
					autoChannel = "INSTANCE_CHAT";
				else
					autoChannel = "RAID";
				end
			end
			SendChatMessage("Swapblasted by " .. UnitName(unitID), autoChannel, DEFAULT_CHAT_FRAME.editBox.languageID);
		else
			SendChatMessage("Swapblasted by " .. UnitName(unitID), announceType, DEFAULT_CHAT_FRAME.editBox.languageID);
		end
	end
end

function SwapCheckEventHandler(self, event, ...) 
	if event == "ADDON_LOADED" and select(1,...) == "SwapCheck" then
		if swpChkEnabled  == nil then
			swpChkEnabled  = 1;
		end
		if swpChkEnabled  == 1 then
			print("SwapCheck is |cff00ff00Enabled|r");
		else
			print("SwapCheck is |cffff0000Disabled|r");
		end
	end
	if event == "UNIT_SPELLCAST_SUCCEEDED" and swpChkEnabled  == 1 then
		local unitID, spell, rank, lineID, spellID = ...;
		
		if spellID == 161399 and UnitIsUnit(unitID, "player") ~= 1 then
			mapCalcMapSize(unitID);
		end
	end
	
	if event == "UNIT_SPELLCAST_SUCCEEDED" and swpChkEnabled  == 1 then
		local unitID, spell, rank, lineID, spellID = ...;
		
		if spellID == 161399 then
			RecordLocation();
			SwapCheck__wait(0.01, SwapCheck, unitID);
		end
	end
end

